<?php
/*******************************************
 @File		conf.php
 @Comment	Configuration File for Authenticat0r scripts
 			Sets some Consts and defines shared Functions
 @written	8/27/05, 23:55
 @Author	derDoc
 @email		derDoc@gmx.de

 Changelog:
-> v1.2: 29.9.2k5, 22:30
	-moved all necc. Consts into here and made them defined()
	-moved all shared funtions into here
	-added Comments
	-changed semantics of begin() now it returns type of service to auth against and false if conn open
	-moved OS Detection here and added define for 'line_delim'
-> v1.3: 12.1.2k6, 17:00
	-added another return val for following-http-get which is the last IP followed
-> v1.4: 27.1.2k6, 3:20
	-moved $online out to here, and made isOpen() set it accordingly, so that Forward will actually work with the first call
	-added version of this file in footer of page
-> v1.4.1: 1.2.2k6, 11:40
	-added DEBUG define for turning off/on all debug output easily
-> v1.5: 2.2.2k6, 13:15
	-removed all '@'s troughout scripts
	-set the error reporting to ALL only if debug is defined
	-noticed that some part of the net still use 10.0.1.7, thats what causes the msg
	'you are already logged in' to appear
-> v1.5.1: 6.2.2k6, 15:50
	-added location to outputs (conf->...)
-> v1.5.2: 9.2.2k6, 11:54
	-added call to isOpen() to begin() that sets $online and sees if conn'x is transient
	-raw_http_statuscode now duly returns false, thus begin() now works as expected
	-changed OS to nix for posix* systems, same charcount
	-added one more debug level (2) that outputs all the raw data
	-added if(DEBUG) everywhere for only outputting when DEBUG>0
	-changed error reporting to E_ALL instead of strict when DEBUG==1 
	-moved error reporting setting ahead of everything else (now also reports if $_S[HTTP_SERVER_SW] is not set) 
	-DEBUG only gets defined if not already set by the page
	
*************************/

define('CONF_VER','1.5.2');
//set username and pass here
#define('USER','vdlorenz');
define('USER','tcriosvelasco');
#define('PASS','V1&u%2*0');
define('PASS','140+lao@tr');
//set what service you want auth'ed
define('AUTH_DHCP',1);
define('AUTH_WLAN',1);

//set outside host, that returns a 200 on a HTTP GET
define('SITE200OK','www.nmsu.edu');
//set any IP thats outside UTEP Net (129.108.0.0/16) and a port you know is open
define('OUTSIDE_IP','192.88.12.9'); //aus-core-at1-0-0-203.tx-bb.net, hop after utep1.utep.edu (.202.1)
define('OUTSIDE_PORT','639');		//MSDP

//define('OUTSIDE_IP','129.108.5.58'); //rlab.cs (use for wlan w/ port 22)
//define('OUTSIDE_PORT','22');
//max retries for auth'ing
define('MAX_RETRIES',1);
//set if you want debug output (1=msgs,2=all) if not overriden
if (!defined('DEBUG')) define('DEBUG',1);

//-------------------------------------------------------------------
	//set error_reporting according to debug
	if (DEBUG==2) error_reporting(E_STRICT | E_ALL);
	else if (DEBUG==1) error_reporting(E_COMPILE_ERROR | E_ERROR | E_CORE_ERROR);
	else error_reporting(0);

	//define line delimiter according to OS and set name
	if (stristr($_SERVER['HTTP_USER_AGENT'],'Windows') || stristr($_SERVER["SERVER_SOFTWARE"],'Win32') ){
		define('OS','win');
		define('LINE_DELIM',"\r\n");
	}else{
		define('OS','nix');
		define('LINE_DELIM',"\n");
	}

	$online = false;

//-------------------------------------------------------------------

/* @Function 	isOpen()
 * @Params		no
 * @Returns		(Bool)
 * Checks if outside connection is open
*/
function isOpen(){
	global $online;
	if (fsockopen(OUTSIDE_IP, OUTSIDE_PORT, $errno, $errstr, 3))
	 	return ($online=true);
	 return ($online=false);
}


/* @Function 	begin()
 * @Params		no
 * @Returns		(String)	- the type of service to auth against or false when open
 * Sends a raw HTTP-Get to the 200OK site and checks return code
 * loads appropiate module for authentication, and also returns open state inverted
*/
function begin(){

	$stat = raw_http_statuscode(SITE200OK,'/',80);

	if ($stat){
		switch($stat){
			case '401':
				if (AUTH_DHCP) require('utep_dhcp.php');
				return 'DHCP';
			case '302':
				if (AUTH_WLAN) require('utep_wlan.php');
				return 'WLAN';
			case '200':
				if (isOpen()) return 'ONLINE';
				else return 'TRANSIENT';
			default:
				if (DEBUG) echo "conf->begin: UNKNOWN Network".LINE_DELIM;
				return 'UNKNOWN';
		}
	}

	return false;
}

/* @Function 	raw_http_get()
 * @Params		$host (String)	- the IP or FQDN of the host to open socket to
 *				$path (String)	- the path to get
 *				$port (String)	- the port to open socket to
 *				$count (int)	- how much octets to get
 * @Returns		(String)		- the returned string
 * Sends a HTTP-Get to $host requesting $path and returns $count octets of returned data
*/
function raw_http_get($host, $path, $port, $count=10000){
		if ($port == 443) $tohost = "ssl://".$host;
		else $tohost = $host;
		$fp = fsockopen($tohost, $port, $errno, $errstr, 30);
		if ($fp){

			$out = "GET $path HTTP/1.1\r\n";
	   		$out .= "Host: $host\r\n";
	   		$out .= "Accept: */*\r\n";
	   		$out .= "Connection: close\r\n\r\n";

   			fwrite($fp, $out);

   			$in='';
   			while (!feof($fp) && $count>0 ){
    			$count -= strlen( ($in2 = fread($fp, $count)) );
    			$in .= $in2;
    		}
   			fclose($fp);
   			return $in;

		}else{
   			if (DEBUG) echo "conf->raw_http_get: <b>Couldn't open connection to $host:80$path <br>$errstr ($errno)<br /></b>".LINE_DELIM;
   		}
   		return false;
}

/* @Function 	raw_http_statuscode()
 * @Params		$h (String)	- the IP or FQDN of the host to open socket to
 *				$p (String)	- the path to get
 *				$po (String)- the port to open socket to
 * @Returns		(String)	- the returned Statuscode
 * Sends a HTTP-Get to $host requesting $path and returns the statuscode returned
*/
function raw_http_statuscode($h, $p, $po){
		//only read 13 chars
		if ($s = raw_http_get($h,$p,$po,13))
			return substr($s, 9, 3);
		return false;
}

/* @Function 	following_raw_http_get()
 * @Params	$h (String)	- the IP or FQDN of the host to open socket to
 *			$p (String)	- the path to get
 *			$po (String)	- the port to open socket to
 * @Returns	array{
 			(String)	- the IP of the last link followed
 			(String)	- the returned string after the last redirect
 		}
 * Sends a HTTP-Get to $host requesting $path follows any redirects (302) and return the last data and IP
*/
function following_raw_http_get($h, $p, $po){

	if (DEBUG) echo "conf->foll_raw_http_get: Getting $h$p ...<br />".LINE_DELIM;

	$raw = raw_http_get($h,$p,$po);

	switch ( substr($raw, 9, 1) ){
		case '2':
			switch ( substr($raw, 10, 2) ){
				case '00':
					if (DEBUG) echo "conf->foll_raw_http_get: Got Code 200 (OK), returning...<br />".LINE_DELIM;
					return array($h,$raw);
				default:
					if (DEBUG) echo "conf->foll_raw_http_get: Got Code ".substr($raw,9,3)." (?), returning...<br />".LINE_DELIM;
					return array($h,$raw);
			}
			break;
		case '3':
			switch ( substr($raw, 10, 2) ){
				case '02':
					preg_match('#Location: (http(s)?://([^/]+)(/.+))#', $raw, $m);
					if (DEBUG) echo "conf->foll_raw_http_get: Got Code 302 (moved), following redirect to ".$m[1]."<br />".LINE_DELIM;
					return following_raw_http_get($m[3], $m[4], ($m[2]=='s' ? 443:80) );
				default:
					if (DEBUG) echo "conf->foll_raw_http_get: Got Code ".substr($raw,9,3)." (?), aborting...<br />".LINE_DELIM;
			}
			break;
		default:
			if (DEBUG) echo "conf->foll_raw_http_get: Got Code " . substr($raw, 9, 3) . "(unknown), aborting...<br />".LINE_DELIM;
			break;
	}
	return false;
}
?>
