<?php
/*******************************************
 @File		online_page.php
 @Comment	Authenticat0r - page version
 			renders nice page with little info about status
 			has buttons to klick on and stuff to set ;)
 			can be kept open in a webbrowser, will reload every <set> seconds
 @written	8/27/05, 23:55
 @Author	derDoc
 @email		derDoc@gmx.de

 Changelog:
-> v2.2: 29.9.2k5, 22:30
	-final rewrite of code
	-everything is moved into proper place (see utep_dhcp.php)
	-added header and some comments
	-moved logging stuff back to _script.php
	-added type of auth service to header
	-changed ping command once again to work with new defines
	-changed line_delims
-> v2.4: 27.1.2k6, 3:20
	-moved $online out to conf.php script, and made isOpen() set it accordingly, so that Forward will actually work with the first call
	-included version of conf.php in footer
-> v2.4.1 6.2.2k6, 15.50
	-added checking before function auth() is called
-> v2.5: 9.2.2k6, 11:54
	-after authenticating its now redirecting after 0 secs to itself
	-added debug switch
	-sets DEBUG accordingly
	-remembers the state during refreshes
	-fixed Location: header, which is set by BlueSocket, needs to be set again, so that it redirects to itself after auth'ing not to SITE200OK
-> v2.6: 14.2.2k6, 1:59
	-changed defines of GOTO/REFRESH to vars
	-introduced a $SH = which command to run

*************************/

//version
define('PAGE_VER','2.6');
//written on
define('WRITTEN','27.1.2k6,0320');

//set these:
//host to ping
define('PINGH','www.nmsu.edu');
//how many times to ping
define('XPING',3);
//where to forward to (initial value of field)
define('INIT_GO','http://faz.net');
//set initial refresh
define('INIT_REFR',1800);
//set initial command to run
define ('INIT_COMM','ping');

//--------------------------------
	//start output buffering, because we sent headers late in the script
	ob_start();
	//get time:
	$msec_start = microtime(true);
	if (isset($_GET['debug'])) define('DEBUG', $_GET['debug']);
	require('conf.php');

	$method = begin();

	//check if windows, if it is set count option for ping to -n
	if (OS=='win')
		 $c = 'n';
	else $c = 'c';



	//set vars if they are set in HTTP GET Request, else set to defs
	if (isset($_GET['goto'])) $GOTO = $_GET['goto'];
	else $GOTO = INIT_GO;
	if (isset($_GET['refr'])) $REFRESH = $_GET['refr'];
	else $REFRESH = INIT_REFR;
	if (isset($_GET['run'])) $SH = $_GET['run'];
	else if (INIT_COMM=='ping') $SH = INIT_COMM . " -$c " . XPING . ' ' . PINGH;
	else $SH = INIT_COMM;


	//title
	echo "<h1>UTEP $method (Re-) Authenticat0r v".PAGE_VER."</h1>".LINE_DELIM;
	echo "<br />";

	//status
	echo '<b>Last checked @ ' . date('r') . ":<br>".LINE_DELIM;
	echo 'Your connection to the outside I-net is <font color="' . ($online ? 'green">open!':'red">closed!') . "</font></b><p />".LINE_DELIM;

	//if open => run command
	if ($online)
		echo ("<pre>" . shell_exec($SH)."</pre>".LINE_DELIM);

//render nice form stuff ;)
echo('<hr /><br />
	<form action="" method="get">
		<input type="hidden" name="do" value="goto">
		Auth and goto: <input type="text" size="20" name="forward" value="'.$GOTO.'" /> &nbsp;
		<input type="checkbox" name="debug" value="2" '.((DEBUG==2)?'checked':'').' /> &nbsp;Debug! &nbsp;
		<input type="submit" value="Go!" />
	</form>
	<p />
	<form action="" method="get">
		<input type="hidden" name="do" value="reauth">
		Auth and refresh/reauth every <input type="text" size="5" name="refr" value="'.$REFRESH.'" /> secs &nbsp;
		<input type="checkbox" name="debug" value="2" '.((DEBUG==2)?'checked':'').' /> &nbsp;Debug!
		and run <input type="text" size="30" name="run" value="'.$SH.'" /> &nbsp;
		<input type="submit" value="Go!" />
	</form>
	<br /><hr />');

//check what we should do if at all
if (isset($_GET['do'])){
		switch($_GET['do']){
			case 'goto':
				//if offline => authenticate
				if (!$online && function_exists('auth')) auth();
				//forward to set host
				if ($online)  header("Location: ".GOTO);
				break;
			case 'reauth':
				//get self
				$self = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
				//if offline => authenticate
				if (!$online && function_exists('auth'))
					if (!auth()){
						header('Location: '.$self);
						break;
					}
				//just reload page every <REFRESH>secs
				header('Refresh: '. $REFRESH. ' ; URL='.$self);
				break;
		}
}

//add execution time and footer
$footer  = " secs; page{v".PAGE_VER."},conf{v".CONF_VER."}; &copy{".WRITTEN."}derDoc";
echo ( "<center><font size='-2'>" . (microtime(true) - $msec_start) . $footer . "</font></center>".LINE_DELIM);
ob_flush();
exit();
?>
