#! /bin/bash
# script to trigger the 'Planetlabber'
# makes use of ParPort.c 

# --var section-- #
#short timeout (for on)
SHORT_TO=1
#long timeout (for off)
LONG_TO=4
#set number of remote triggers here
NUM=3
#set offset=1 if you skipped the first data-line
OFS=0
# ---end var section--- #

#set the mask to appropiate dec. value
MASK=$(echo "(2^$NUM)-1" | bc)

#and now set the byte to the ones we actually want to trigger if given
arg2=$2

#second arg zero || greater 8 => set to 255
[[ -z "$arg2" || "$arg2" > 8 ]] && arg2=255

#second arg < 9 => shift bit into right place
[[ "$arg2" < 9 ]] && arg2=$((1<<($arg2-1)))

#apply mask and shift with offset
BYTE=$(( (arg2&MASK) << OFS ))

#function that handles both starting and stopping with diff. TO
starp() {
		#pull down all the bits first
		./ParPort 0
		#then set them
		./ParPort $BYTE
		#wait a while
		sleep $1
		#and pull down again
		./ParPort 0
}

case "$1" in
	start)
		starp $SHORT_TO 
		if [ -z "$2" ]
		then echo "started all Labbers"
		else echo "started Labber #$2" 
		fi ;;
		
	stop)
		starp $LONG_TO 
		if [ -z "$2" ]
		then echo "stopped all Labbers"
		else echo "stopped Labber #$2" 
		fi ;;

	"" | restart)
		starp $LONG_TO ;;
		starp $SHORT_TO ;;
		if [ -z "$2" ]
		then echo "restarted all Labbers"
		else echo "restarted Labber #$2" 
		fi ;;
	
	*) echo "Usage: ${0##*/} [start|stop|restart] [<num>]"; exit $E_PARAM;;
			# everything else. 
		
esac


