
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Student 	 	 :-	Samson Joseph Dev		       %%
%% Course# 	 	 :-	5303				       %%
%% Course name 		 :-     Logical Foundations of Computer Science%%
%% Programming Assignment:-	1				       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%% DEFINITIONS %%%%%%%%%

:-op(600,fy,'~').      % This symbol is used for representing Negation
:-op(670,xfy,&).       % This symbol is used to represent logical "and"(conjunction)
:-op(675,xfy,'V').     % This symbol is used to represent logical "or" disjonction
:-op(680,xfy, '->').   % This symbol is used to represent logical "implication"
:-op(700,xfy,'<->').   % This symbol is used to represent logical "equivalence" 

%%%%%%%%%%%%%%%%%%%%%%%% TRANSFORMATIONS %%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%
%% Equivalence %%
%%%%%%%%%%%%%%%%%
eq(Form1 '<->' Form2,  (Memb1 & Memb2)) :-
 !,
  eq(Form1 '->' Form2, Memb1),
  eq(Form2 '->' Form1, Memb2).
eq(Form1 & Form2, Memb1 & Memb2) :-
  !,
  eq(Form1, Memb1),
  eq(Form2, Memb2).
eq(Form1 'V' Form2, Memb1 'V' Memb2) :-
  !,
  eq(Form1, Memb1),
  eq(Form2, Memb2).
eq(Form1 '->' Form2, Memb1 '->' Memb2) :-
  !,
  eq(Form1, Memb1),
  eq(Form2, Memb2).
eq('~' Form, '~' Memb) :-
  !,
  eq(Form, Memb).
eq(P,P).

%%%%%%%%%%%%%%%%%%%%%%
%% Implication      %%
%%%%%%%%%%%%%%%%%%%%%%

imply(Form1 '->' Form2, '~' Memb1 'V' Memb2) :-
  !,
  imply(Form1, Memb1),
  imply(Form2, Memb2).
imply(Form1 & Form2, Memb1 & Memb2) :-
  !,
  imply(Form1, Memb1),
  imply(Form2, Memb2).
imply(Form1 'V' Form2, Memb1 'V' Memb2) :-
  !,
  imply(Form1, Memb1),
  imply(Form2, Memb2).
imply('~' Form, '~' Memb) :-
  !,
  imply(Form, Memb).
imply(P,P) :-
  atom(P).

%%%%%%%%%%%%%%%%%%%%%%
%%    Negation      %%
%%%%%%%%%%%%%%%%%%%%%%

negate('~' '~' Form, Res) :-
  !,
  negate(Form,Res).
negate('~' (Form1 & Form2), (Res1 'V' Res2)) :-
  !,
  negate('~' Form1, Res1),
 negate('~' Form2, Res2).
negate('~' (Form1 'V' Form2), (Res1 & Res2)) :-
  !,
  negate('~' Form1, Res1),
  negate('~' Form2, Res2).
negate('~' P, '~' P) :-
  !,
  atom(P).
negate(Form1 & Form2, Memb1 & Memb2) :-
  !,
  negate(Form1, Memb1),
  negate(Form2, Memb2).
negate(Form1 'V' Form2, Memb1 'V' Memb2) :-
  !,
 negate(Form1, Memb1),
  negate(Form2, Memb2).
negate(P, P) :-
  atom(P).

%%%%%%%%%%%%%%%%%%%%
%%  Distributions %%
%%%%%%%%%%%%%%%%%%%%

distribution((G1 & G2) 'V' D, R1 & R2) :-
  !,
  distribution(G1 'V' D,R1),
 distribution(G2 'V' D,R2).
distribution(G 'V' (D1 & D2), R1 & R2) :-
  !,
  distribution(G 'V' D1,R1),
  distribution(G 'V' D2,R2).
distribution((F1 'V' F2) 'V' F3, F) :-
  !,
  distribution(F2 'V' F3, R1),
  distribution(F1 'V' R1, F).
distribution(F1 & F2, R1 & R2) :-
  !,
  distribution(F1, R1),
  distribution(F2, R2).
distribution(F, F).

%%%%%%%%%%%%%%%%%%%%
%% Associativities %%
%%%%%%%%%%%%%%%%%%%%


associate((F1 'V' F2) 'V' F3, F1a 'V' (F2a 'V' F3a)) :-
   !,
  associate(F1, F1a),
   associate(F2, F2a),
   associate(F3, F3a).

associate(F1 'V' (F2 'V' F3), F1a 'V' (F2a 'V' F3a)) :-
   !,
  associate(F1, F1a),
  associate(F2, F2a),
   associate(F3, F3a).
associate(F,F).



%%%%%%%%%%%%%%%%%%%%%%%
%% -->  CNF          %%
%%%%%%%%%%%%%%%%%%%%%%%
%%%% This is the function that does all the parsing and conversion things for the%%%%
%%%% formula entered.								 %%%%

t_CNF(Frm,FNC) :-
   eq(Frm, Frm1),				%%Checks the equivalence class%%
   imply(Frm1,Frm2),				%%Checks the Implication class%%
   negate(Frm2,Frm3),				%%Checks the Negation class%%
   distribution(Frm3,Frm4),			%%Checks the Distribution class%%
   associate(Frm4,FNC).				%%Checks the Associativity class%%


%%%%%%%%%%%%%% TESTS %%%%%%%%%%%%%%

%% Test de la FNC
t_fnc :-
  t_CNF(
       '~'(('~'(a '->' '~' b) '<->' (b & ('~' c 'V' a))))
       ,C),
  write(C).



