<?php
/*******************************************
 @File		speed_tester.php
 @Comment	Tests your download speed
 			does this by going to google's zeitgeist, taking a random entry,
 			doing agoogle pic search for it, and again taking some random img from there
 			downloading it and measuring the time
 @written	2/16/06, 16:15
 @Author	derDoc
 @email		derDoc@gmx.de

 Changelog:
-> v0.1: 16.2.2k6, 16:15
	-initial version
	
***************************/
//---------------defines-------------
define('IMG_SEARCH','http://images.google.com/images?imgsz=xxlarge&q=');
define('ZEITGEIST','http://www.google.com/press/zeitgeist.html');
define('TIMES',10);
//----------------------------------


function get_speed($url){
	
	if (preg_match_all('#^http://([^/]+)(/.+)$#',$url, $url_matches)){
		$host = $url_matches[1][0];
		$path = $url_matches[2][0];
		
	
		$fp = fsockopen($host, 80, $errno, $errstr, 10);
		if ($fp){
			$out = "GET $path HTTP/1.1\r\n";
	   		$out .= "Host: $host\r\n";
   			$out .= "Accept: */*\r\n";
   			$out .= "Connection: close\r\n\r\n";
   			fwrite($fp, $out);
   			
   			$msec_start = microtime(true);
			while (!feof($fp))
    			$in .= fgets($fp, pow(2,16));
			$msec_end = microtime(true);
			$time = $msec_end - $msec_start;
			
			fclose($fp);
		/*
			echo "<br>Read " . strlen($in) . " bytes in $time secs<br>";
			echo "Thats " . ($bps=(strlen($in)/$time)) . " bytes/sec <br>";
			echo "Thats " . ((strlen($in)/$time)/1024) . " kbytes/sec <br>";
			echo "Thats " . ((strlen($in)/$time)/(1024*1024)) . " mbytes/sec <br>";
		*/
			if (strlen($in) < (64*1024)) return false;
			return array(strlen($in),$time);
   		}else{
   			echo "Error $errno in fsockopen: $errstr";
   		}
	}
	return false;	
}

function measure_speed(){
	
	$i = 0;
	
	$zeitgeist = file_get_contents(ZEITGEIST);
	if (preg_match_all('#search\?q=[^>]+>([^<]+)</a></td>#',$zeitgeist, $zg_matches)){
	
		while($i < TIMES){
		
			$str = $zg_matches[1][rand(0,14)];
			if (empty($str)) continue;
//			echo "getting pix for $str<br>";
			$pix = file_get_contents(IMG_SEARCH . urlencode($str));

			//match against all the image urls
			if (preg_match_all('#/imgres\?imgurl=(http://[^&]+)&imgrefurl=#',$pix, $p_matches)){
/*				echo "pix are: ";
				print_r($p_matches);
				echo "<br>";
*/			
				//download image and get speed
				if (($url=$p_matches[1][rand(0,19)]) && (list($s,$t) = get_speed($url))){
					
					echo round((($s/$t)/1024),3) . " kbps from $url (". round($s/1024,3) . " kbytes)<br>";
					flush();
					$i++;
					$vals[] = ($s/$t);
				}
			}
		}
		
		foreach($vals as $val)
			$sum += $val;
		echo "Avg. down bandwith: " . round(($sum/count($vals))/1024,5) . " kbps<br>";
	}
	

}


measure_speed();


?>