#!/bin/php
<?php
/*******************************************
 @File		online_script.php
 @Comment	Authenticat0r - script version
 			does not yield any output other than stderr, logs to file if set
 			can be kicked off by cron, for example like this
 			"* * * * * root <pathto>/online_script.php > /var/log/online.out" in your /etc/crontab
 @written	8/27/05, 23:55
 @Author	derDoc
 @email		derDoc@gmx.de

 Changelog:
-> v1.2: 29.9.2k5, 22:30
	-added LOG switchable by DOLOG
	-returns 0 on success or 1 otherwise
	-turns off any output from script while working
	-added type of auth to log
	-removed warning for LOGFILE if not run as root
	-changed line delims
-> v1.2.1: 1.2.2k6, 10:35
	-but redefinition of CONSTs does not work -> introduced a variable 'nolog'
	-added some more '@'s to suppress warnings
-> v1.3: 2.2.2k6, 13:15
	-removed '@'s again
	-added the IP that was authenticated against to log file
-> v1.3.1: 6.2.2k6, 15:35
	-moved ob_start to top
	-added option for out file -> it will get all the output and log it to the set file instead of discarding
	-added some more comment noise
-> v1.4: 7.2.2k6, 15:00
	-cleaned up output to file
	-init for $autehd_ip
-> v1.4.1: 8.2.2k6, 11:55
	-renamed posix to nix.. same char count as win 
	-changed defining of log files, now has path and name
	-easier setting of final path, uses ternary op
	-gets set _after_ conf is included not before (OS is set there: dooh!)
	-fps were wrong, fixed that
	-defined a $stat so that the logfile does'nt say 'Opened' despite of error
-> v1.4.2: 9.2.2k6, 11:35
	changed php path to /usr/bin/php which is default on most OS'es
	
***************************/
//---------------defines-------------

//do logging?
define('DOLOG',1);
//capture output and log to file?
define('DOOUT',1);
//log file to log to
define('LOG_FILE_NAME','online_script.log');
//outfile for noise
define('OUT_FILE_NAME','online_script.out');
//path depending on os
define('LOG_PATH_WIN','C:\\');
define('LOG_PATH_NIX','/var/log/');
//set to 1 if you only want the auths logged, ie. no echo if conn already open
define('LOG_OPENED_ONLY',1);

//---------------------------------------

//get start time of script
$msec_start = microtime(true);
//sets Output buffering on, turns off any output from script
ob_start();
//preset vars (good idea in a script... never trust that they are init'ed to 0/'', coz user may have set them)
$return_code = 255;
$authed_ip = '';
$stat = 'Error';

//parse config
require('conf.php');
//set paths
define('LOG_FILE', ( (OS=='nix')?LOG_PATH_NIX:LOG_PATH_WIN ) . LOG_FILE_NAME);
define('OUT_FILE', ( (OS=='nix')?LOG_PATH_NIX:LOG_PATH_WIN ) . OUT_FILE_NAME);

//open log file
if(DOLOG)
	if (!$fl=fopen(LOG_FILE,'a+'))
		$nolog=true;

//open out file
if(DOOUT)
	if (!$fo=fopen(OUT_FILE,'a+'))
		$noout=true;


//check if conn is already open
if (isOpen()){
	//log that conn is already open, but only if defined by LOG_OPENED_ONLY
	if (!LOG_OPENED_ONLY && DOLOG && !$nolog)
		fwrite($fl,date('c').','.(round((microtime(true)-$msec_start),5))."s,Open,0".LINE_DELIM);
	exit(0);
}else{
		//call to conf.php->begin(): opens conn and checks Status code
		//will tell you if you have to auth against DHCP or WLAN
		//it also includes appropiate file so that auth() is defined the right way
		$method = begin();
		//then we just have to call auth, which does the right thing
		if (function_exists('auth')) $return_code = auth();
		else if (DEBUG) echo "script: UNKNOWN Network error, auth() not defined";
	
		if (!$return_code) $stat = 'Opened';

		//if logfile is defined and open log our action to it
		if(DOLOG && !$nolog)
			fwrite($fl,date('c').','.(round((microtime(true)-$msec_start),5)).'s,'.$stat.','.$method.','.$authed_ip.','.$return_code.LINE_DELIM);

		//if outfile is defined write all the script's output to it
		if (DOOUT && !$noout)
			fwrite($fo,'---------'.date('c').'---------'.LINE_DELIM.ob_get_clean().LINE_DELIM);
		//turn Output buffering off and silently disregard any contents
		else ob_end_clean();


		exit($return_code);
}
?>
