<?php
/*******************************************
 @File		utep_wlan.php
 @Comment	helper function for Authenticat0r
 			will auth against WLAN, aka. BlueSocket, authenticator service @UTEP
 @written 	9/22/05, 14:00
 @Author 	derDoc
 @email 	derDoc@gmx.de

 @Changelog
-> v1.0: 9/22/05, 14:00
	-nice form for options
	-functions for relevant stuff
	-vars for everything
	-auth() actually follows 2 redirects and parses raw http to get strings and addresses
	-uses underlying ssl:// proto for Form POST
	-sets every param login.pl wants
-> v1.2: 9/24/05, 12:55
	-added $max_retries var
	-added <hr> before output from auth()
	-reniced output from auth() a little (more info)
	-added execution time
	-added times to ping ($Xping)
-> v1.4: 9/25/2k5, 21:15
	-added $ver to header
	-moved following of redirects out of ugly nested if's into recursive function
	-also gives some more informative output on the way
	-last fixes
-> v2.0: 29.9.2k5, 22:30
	-moved code around (see utep.dhcp.php)
	-now this only houses the auth() function for wlan
	-everything else is moved:
	-script version is in online_script.php
	-page version is in online_page.php
	-shared configuration/functs are in conf.php
	-cleaned header slightly
	-added comments
	-forgot to add 'global $return_code' :) "dooh!'
	-added line_delims
-> v2.1: 12.1.2k6, 17:00
	-added another return val for following-http-get which is the last IP followed
	-solves the problem of not knowing the IP to send form data to
-> v2.1.1: 1.2.2k6, 11:40
	-now detects if already logged in
	-added DEBUG output selection
	-added a global var that holds the ip we authenticated (the BlueSocket IP)
-> v2.2: 7.2.2k6, 15:00
	-changed the return code back to a return var
	-added code spot (name) to all output
	-rewrote return code parser to use switch (cleaner)
	-also added traps for all possible cases while doing it
-> v2.2.1: 9.2.2k6, 11:54
	-changed debug level of raw-output to 2 (INSANE)
	-changed debug level of all other output to 1 (ALL)
	-cleaned up errors in output
	-removed inconsistencies in <hr> for output

********************************************/


/* @Function	auth()
 * @Params		no
 * @Returns		no
 * authenticates against WLAN authentication service (BlueSocket suxxx) @ UTEP
*/
function auth(){
	global $authed_ip;
	$return_code = 255;
	$i=0;
	
	while ( !isOpen() && $i<MAX_RETRIES ){

			if ( list($m_server,$raw_http_form) = following_raw_http_get(SITE200OK,'/',80) ){
				if (DEBUG) echo "wlan->auth: m_server is <pre>$m_server</pre><br />".LINE_DELIM;
				if (DEBUG > 1) echo "<hr>wlan->auth: raw_form is<br><pre>$raw_http_form</pre><hr>".LINE_DELIM;

				preg_match('#name="source" value="([^"]+)"#',$raw_http_form,$m_source);
				preg_match('#method="POST" action="([^"]+)"#',$raw_http_form,$m_act);

				if (DEBUG) echo "wlan->auth: Got Code 200 (OK), opening conn to ssl://".$m_server."<br />".LINE_DELIM;

				//now do the magic:
				if ($fp = fsockopen("ssl://".$m_server, 443, $errno, $errstr, 30)){
					if (DEBUG) echo "wlan->auth: Sending Auth POST data for source=".$m_source[1]."<br />".LINE_DELIM;
					//build the data to submit...
					$data = "_FORM_SUBMIT=" . urlencode('1');
					$data .= "&which_form=" . urlencode('reg');
					$data .= "&destination=" . urlencode(SITE200OK);
					$data .= "&source=" . urlencode($m_source[1]);
					$data .= "&error=" . urlencode('');
					$data .= "&bs_name=" . urlencode(USER);
					$data .= "&bs_password=" . urlencode(PASS);
					$data .= "&SUBMIT=" . urlencode('Log In');
					//now build the string to submit...

					$write = "POST {$m_act[1]} HTTP/1.0\r\n";
					$write .= "Host: " . $m_server . "\r\n";
					$write .= "Content-Type: application/x-www-form-urlencoded\r\n";
					$write .= "Content-length: " . strlen($data) . "\r\n";
					$write .= "Accept: */*\r\n\r\n";

					$all =  $write.$data."\r\n\r\n";
					if (DEBUG > 1) echo "<hr>wlan->auth: raw_post is<br><pre>$all</pre><hr>".LINE_DELIM;

					//and write:
					fwrite($fp, $all);
					//check
					if (DEBUG) echo "wlan->auth: Authenticated..., reading:<br />".LINE_DELIM;

   					$in = '';
   					while (!feof($fp))
    					$in .= fgets($fp,128);
					fclose($fp);

					if (DEBUG > 1) echo "<br>wlan->auth: raw_read <br><pre>$in</pre><hr>".LINE_DELIM;

					switch(substr($in,9,3)){
						case '':
							if (DEBUG) echo "wlan->auth: Failed: nothing read!<br />".LINE_DELIM;
							break;

						case '302':
							if (DEBUG) echo "wlan->auth: Code ".(substr($in,9,3));
							if (stristr($in,SITE200OK))
								if (DEBUG) echo " Success: moved to ".SITE200OK."<br />".LINE_DELIM;
							else
								if (DEBUG) echo " Error: moved to {GOTO}<br />".LINE_DELIM;
							break;

						case '200':
							if (DEBUG) echo "wlan->auth: Code ".(substr($in,9,3));
							if (stristr($in,'UTEP Wireless')){
								if (stristr($in,'Registered Users')){
									if (stristr($in,'User already logged in from another computer'))
										if (DEBUG) echo " Error: Logged in from another computer/domain(this:$m_server),log out first<br />".LINE_DELIM;
									else
										if (DEBUG) echo " Error: Got BlueSocket Login page again<br />".LINE_DELIM;
								}else if(stristr($in,'Thank you for signing in'))
									if (DEBUG) echo " Success: Logged in<br />".LINE_DELIM;		
								else
									if (DEBUG) echo " Failed: Unknown Page!<br />".LINE_DELIM;
								
							}else if (stristr($in,SITE200OK))
								if (DEBUG) echo " Success: Logged in<br />".LINE_DELIM;		
							else
								if (DEBUG) echo " Failed: Unknown Page!<br />".LINE_DELIM;
	   						break;

	   					default:
	   						if (DEBUG) echo "wlan->auth: Code ".(substr($in,9,3));
							if (DEBUG) echo " Failed: Unknown Page!<br />".LINE_DELIM;
							break;
	   				}
	   			}else
		   			if (DEBUG) echo "wlan->auth: Error in fsockopen(ssl://{$matches2[3]}): $errstr ($errno)<br />".LINE_DELIM;
   		 	}else
		   			if (DEBUG) echo "wlan->auth: Failed to follow redirects!<br />".LINE_DELIM;
   		 
		$i++;
	}

	if (!isOpen()){
		if (DEBUG) echo "wlan->auth: Failed to authenticate!<br /><hr />".LINE_DELIM;
		$return_code = 1;
	}else{
		if (DEBUG) echo "wlan->auth: Connection open!<br /><hr />".LINE_DELIM;
		$return_code = 0;
		$authed_ip = $m_server;
	}
	
	return ($return_code);

}

?>
